﻿Imports Microsoft.Win32

Module Module1

    Dim strCurrentLocation As String
    Dim boolDebug As Boolean

    Sub Main()

        Dim arrStartupArguments() As String
        Dim intLoop As Integer
        Dim intColumns As Integer
        Dim intRows As Integer
        Dim longBegin As Long
        Dim intThumbWidth As Integer
        Dim strFilenamePath As String

        ' ##### Identify if we are running in Visual Studio/IDE and frig the current location if we are #####
        If InIDE() Then
            strCurrentLocation = "c:\temp\thumbnailer"
        Else
            ' ##### Not running in IDE, so set the location to be the current directory #####
            strCurrentLocation = System.AppDomain.CurrentDomain.BaseDirectory
        End If

        ' ##### Check if we are running in debug - either registry key or flag file #####
        If RegistryDebugFlag() Or System.IO.File.Exists(strCurrentLocation & "\mtn.debug") Then
            boolDebug = True
        End If

        If boolDebug Then
            Logfile("######################### Starting MTN Replacement (" & System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString() & _
                ") - By Jay_UK ###########################")
        End If

        ' ##### Read the commandline arguments into an array #####
        arrStartupArguments = System.Environment.GetCommandLineArgs

        Try
            ' ##### Make sure we have some commandline options #####
            If UBound(arrStartupArguments) < 3 Then
                If boolDebug Then
                    Logfile("...ERROR - Invalid commandline!!")
                    Logfile("################################### Finished MTN Replacement #####################################")
                End If
                End
            End If

        Catch ex As Exception
            ' ##### We have a problem with the commandline arguments - so lets quit! #####
            If boolDebug Then
                Logfile("...ERROR - Invalid commandline!!")
                Logfile("################################### Finished MTN Replacement #####################################")
            End If
            End
        End Try

        ' ##### Check FFmpeg.exe exists in the same directory as this EXE #####
        If Not System.IO.File.Exists(strCurrentLocation & "\ffmpeg.exe") Then
            If boolDebug Then
                Logfile("...ERROR - Failed to find ffmpeg.exe in the current directory!!")
                Logfile("################################### Finished MTN Replacement #####################################")
            End If
            End
        End If

        ' ##### The whole commandline arguments (as a single string) #####
        If boolDebug Then
            Logfile("Commandline options: " & Command$())
        End If

        ' ##### Lets loop through each one #####
        For intLoop = LBound(arrStartupArguments) To UBound(arrStartupArguments)

            Select Case True
                ' ##### Number of columns in the thumbnail #####
                Case arrStartupArguments(intLoop) = "-c" And intLoop < UBound(arrStartupArguments)
                    intColumns = arrStartupArguments(intLoop + 1)

                    ' ##### Number of rows in the thumbnail #####
                Case arrStartupArguments(intLoop) = "-r" And intLoop < UBound(arrStartupArguments)
                    intRows = arrStartupArguments(intLoop + 1)

                    ' ##### Space at the beginning before a grab is done #####
                Case arrStartupArguments(intLoop) = "-B" And intLoop < UBound(arrStartupArguments)
                    longBegin = arrStartupArguments(intLoop + 1)

                    ' ##### Width of the thumbnail #####
                Case arrStartupArguments(intLoop) = "-w" And intLoop < UBound(arrStartupArguments)
                    intThumbWidth = arrStartupArguments(intLoop + 1)

            End Select
        Next

        ' ##### If no width has been set, we'll assume a default width of 1270 #####
        If intThumbWidth = 0 Then
            intThumbWidth = 1270
        End If

        ' ##### Make sure we have a " in the commandline options - we'll switch to the whole string version #####
        If InStr(Command$, Chr(34)) < 0 Then
            If boolDebug Then
                Logfile("...ERROR - Invalid commandline!!")
                Logfile("################################### Finished MTN Replacement #####################################")
            End If
            End
        End If

        ' ##### Lets split the whole command string based on " #####
        arrStartupArguments = Split(Command$, Chr(34))

        ' ##### Lets get the filename of the movie - assuming the filename is the last commandline option #####
        ' ##### We'll replace and / with \ #####
        strFilenamePath = Replace(arrStartupArguments(1), "/", "\")

        If boolDebug Then
            Logfile("Beginning position: " & longBegin)
            Logfile("Number of rows: " & intRows)
            Logfile("Number of columns: " & intColumns)
            Logfile("Thumbnail width: " & intThumbWidth)
        End If

        ' ##### Lets check if we are processing a directory or file #####
        If Right(strFilenamePath, 1) = "\" Or System.IO.Directory.Exists(strFilenamePath) Then
            If boolDebug Then
                Logfile("Batch mode: Yes")
            End If

            ' ##### If the path has a \ on the end, lets remove it #####
            If Right(strFilenamePath, 1) = "\" Then
                strFilenamePath = Left(strFilenamePath, Len(strFilenamePath) - 1)
            End If

            ' ##### Lets batch process the movies #####
            Batch(strFilenamePath, intRows, intColumns, longBegin, intThumbWidth)
        Else
            If boolDebug Then
                Logfile("Batch mode: No")
            End If

            ' ##### Lets process the specific single movie #####
            ProcessMovie(strFilenamePath, intRows, intColumns, longBegin, intThumbWidth, "")
        End If

        If boolDebug Then
            Logfile("################################### Finished MTN Replacement #####################################")
        End If
    End Sub
    Sub Batch(ByVal strFilenamePath, ByVal intRows, ByVal intColumns, ByVal longBegin, ByVal intThumbWidth)

        ' ##### Crude error handling - simply ignore the error and continue #####
        On Error Resume Next

        Dim strFile As String

        If boolDebug Then
            Logfile("===================================================================================")
            Logfile("Processing folder: " & strFilenamePath)
        End If

        ' ##### Lets check the folder exists #####
        If Not System.IO.Directory.Exists(strFilenamePath) Then
            If boolDebug Then
                Logfile("...ERROR - Folder does not exist: " & strFilenamePath)
            End If
            Exit Sub
        End If

        ' ##### Bind to the directory #####
        Dim objFolder As New IO.DirectoryInfo(strFilenamePath)

        ' ##### Build a list of subfolders #####
        Dim objSubFolders As IO.DirectoryInfo() = objFolder.GetDirectories()

        ' ##### Build a list of files in the current folder #####
        Dim objFiles As IO.FileInfo() = objFolder.GetFiles()

        Dim objFile As IO.FileInfo

        ' ###### Loop through each file in the directory #####
        For Each objFile In objFiles

            strFile = objFile.Name

            ' ##### Lets process the individual movie #####
            ProcessMovie(strFile, intRows, intColumns, longBegin, intThumbWidth, "...")
        Next

        ' ##### Lets recurse through each subfolder by calling this sub again #####
        For Each objSubFolder In objSubFolders
            Batch(objSubFolder, intRows, intColumns, longBegin, intThumbWidth)
        Next


    End Sub

    Sub ProcessMovie(ByVal strFilenamePath As String, ByVal intRows As Integer, ByVal intColumns As Integer, _
                     ByVal longBegin As Long, ByVal intThumbWidth As Integer, ByVal strIndent As String)

        Dim strOutputFilename As String
        Dim strFilename As String
        Dim strPath As String
        Dim strFilenamewithoutExtension
        Dim arrCommand
        Dim intLoop As Integer
        Dim strCommandOutput As String
        Dim strDuration As String
        Dim longNumberOfSeconds As Long
        Dim intTileWidth As Integer
        Dim intTileHeight As Integer

        ' ##### Only process movie files #####
        If Not (Right(strFilenamePath, 3) = ".ts" Or Right(strFilenamePath, 4) = ".avi" Or Right(strFilenamePath, 4) = ".mkv" Or _
            Right(strFilenamePath, 4) = ".mpg" Or Right(strFilenamePath, 4) = ".3gp" Or Right(strFilenamePath, 4) = ".3g2" Or _
            Right(strFilenamePath, 4) = ".asf" Or Right(strFilenamePath, 4) = ".avs" Or Right(strFilenamePath, 4) = ".dat" Or _
            Right(strFilenamePath, 5) = ".divx" Or Right(strFilenamePath, 4) = ".dsm" Or Right(strFilenamePath, 4) = ".evo" Or _
            Right(strFilenamePath, 4) = ".flv" Or Right(strFilenamePath, 4) = ".m1v" Or Right(strFilenamePath, 5) = ".m2ts" Or _
            Right(strFilenamePath, 4) = ".m2v" Or Right(strFilenamePath, 4) = ".m4a" Or Right(strFilenamePath, 4) = ".mj2" Or _
            Right(strFilenamePath, 5) = ".mjpg" Or Right(strFilenamePath, 5) = ".mjpeg" Or Right(strFilenamePath, 4) = ".mov" Or _
            Right(strFilenamePath, 5) = ".moov" Or Right(strFilenamePath, 4) = ".mp4" Or Right(strFilenamePath, 5) = ".mpeg" Or _
            Right(strFilenamePath, 4) = ".mpv" Or Right(strFilenamePath, 4) = ".nut" Or Right(strFilenamePath, 4) = ".ogg" Or _
            Right(strFilenamePath, 4) = ".ogm" Or Right(strFilenamePath, 3) = ".qt" Or Right(strFilenamePath, 3) = ".rm" Or _
            Right(strFilenamePath, 5) = ".rmvb" Or Right(strFilenamePath, 4) = ".swf" Or Right(strFilenamePath, 3) = ".ts" Or _
            Right(strFilenamePath, 4) = ".vob" Or Right(strFilenamePath, 4) = ".wmv" Or Right(strFilenamePath, 5) = ".xvid") Then

            If boolDebug Then
                Logfile(strIndent & "-----------------------------------------------------------------------------------")
                Logfile(strIndent & "...ERROR - Unsupported file type: " & strFilenamePath)
            End If
            Exit Sub
        End If

        If boolDebug Then
            Logfile(strIndent & "-----------------------------------------------------------------------------------")
            Logfile(strIndent & "Movie file (with path): " & strFilenamePath)
        End If

        ' ##### Lets check the specific movie exists #####
        If Not System.IO.File.Exists(strFilenamePath) Then
            If boolDebug Then
                Logfile(strIndent & "...ERROR - Movie not found!!")
            End If
            Exit Sub
        Else
            If boolDebug Then
                Logfile(strIndent & "...Found movie")
            End If
        End If

        ' ##### Lets split the movie path based on \ #####
        arrCommand = Split(strFilenamePath, "\")

        strPath = arrCommand(0)

        ' ##### Lets build the path (without the filename) #####
        For intLoop = 1 To UBound(arrCommand) - 1
            strPath = strPath & "\" & arrCommand(intLoop)
        Next

        ' ##### The movie name (without path) #####
        strFilename = arrCommand(UBound(arrCommand))

        ' ##### Lets check if the movie name has a . in it #####
        If InStr(strFilename, ".") > 0 Then

            ' ##### It does so lets split on it #####
            arrCommand = Split(strFilename, ".")

            ' ##### Now lets rebuild the filename but without the extension #####
            strFilenamewithoutExtension = arrCommand(0)

            For intLoop = 1 To UBound(arrCommand) - 1

                strFilenamewithoutExtension = strFilenamewithoutExtension & "." & arrCommand(intLoop)
            Next
        Else
            ' ##### The movie filename does not have a . therefore it doesnt have an extension #####
            strFilenamewithoutExtension = strFilename
        End If

        If boolDebug Then
            Logfile(strIndent & "...Movie filename: " & strFilename)
            Logfile(strIndent & "...Movie path (without filename): " & strPath)
            Logfile(strIndent & "...Movie filename without extension: " & strFilenamewithoutExtension)
        End If

        ' ##### Mediaportal expects the thumbnail to be in the same folder as the movie #####
        ' ##### Post processing by Mediaportal resizes and moves the thumbnail to the correct location #####
        strOutputFilename = strPath & "\" & strFilenamewithoutExtension

        ' ##### Lets check the thumbnails dont already exist #####
        Select Case True
            Case System.IO.File.Exists(strPath & "\" & strFilenamewithoutExtension & ".jpg")
                If boolDebug Then
                    Logfile(strIndent & "......Aborting Process - Thumbnail already exists: " & strPath & "\" & strFilenamewithoutExtension & ".jpg")
                End If
                Exit Sub

            Case System.IO.File.Exists(strPath & "\" & strFilenamewithoutExtension & "_s.jpg")
                If boolDebug Then
                    Logfile(strIndent & "......Aborting Process - Thumbnail already exists: " & strPath & "\" & strFilenamewithoutExtension & "_s.jpg")
                End If
                Exit Sub

            Case System.IO.File.Exists(Environ$("ALLUSERSPROFILE") & "\Team Mediaportal\Mediaportal\Thumbs\TV\Recorded\" & strFilenamewithoutExtension & ".jpg")
                If boolDebug Then
                    Logfile(strIndent & "......Aborting Process - Thumbnail already exists: " & Environ$("ALLUSERSPROFILE") & _
                        "\Team Mediaportal\Mediaportal\Thumbs\TV\Recorded\" & strFilenamewithoutExtension & ".jpg")
                End If
                Exit Sub

            Case System.IO.File.Exists(Environ$("ALLUSERSPROFILE") & "\Team Mediaportal\Mediaportal\Thumbs\videos\" & strFilenamewithoutExtension & ".jpg")
                If boolDebug Then
                    Logfile(strIndent & "......Aborting Process - Thumbnail already exists: " & Environ$("ALLUSERSPROFILE") & _
                        "\Team Mediaportal\Mediaportal\Thumbs\Videos\" & strFilenamewithoutExtension & ".jpg")
                End If
                Exit Sub
        End Select

        ' ##### Lets check we have the minimum options we need to proceed #####
        If intColumns = 0 Or intRows = 0 Or strFilenamePath = "" Or strFilename = "" Then
            If boolDebug Then
                Logfile(strIndent & "...ERROR - Invalid commandline!!")
            End If
            Exit Sub
        End If

        If boolDebug Then
            Logfile(strIndent & "...Calculating length of movie (seconds)")
        End If

        ' ##### Lets run FFmpeg to get info on the movie  #####
        strCommandOutput = CaptureShell(strCurrentLocation & "\ffmpeg.exe", " -i " & Chr(34) & strFilenamePath & Chr(34), 20, True)

        ' ##### Lets check we have the word "Duration" in the output from FFMpeg #####
        If InStr(strCommandOutput, "Duration") < 0 Then
            If boolDebug Then
                Logfile(strIndent & "...ERROR - Failed to extract duration from the movie")
            End If
            Exit Sub
        End If

        Try
            ' ##### Lets get the duration of the movie from the FFmpeg output #####
            strDuration = Mid(strCommandOutput, InStr(1, strCommandOutput, "Duration: ") + 10, 8)
        Catch ex As Exception
            If boolDebug Then
                Logfile(strIndent & "...ERROR - Failed to extract duration from the movie")
            End If
            Exit Sub
        End Try

        ' ##### Lets convert the duration 00:00:00 into seconds #####
        longNumberOfSeconds = ConvertToSeconds(strDuration)

        ' ##### If the movie is less than 60 seconds we wont thumbnail it #####
        If longNumberOfSeconds < 60 Then
            If boolDebug Then
                Logfile(strIndent & "...ERROR - Movie length is too short: " & longNumberOfSeconds)
            End If
            Exit Sub
        End If

        If boolDebug Then
            Logfile(strIndent & "......Length is: " & longNumberOfSeconds)
        End If

        ' ##### Lets check the specified begin start position is appropriate for the movie length #####
        ' ##### If its too large, we will automatically adjust it #####
        If longBegin > (longNumberOfSeconds - (20 * intRows * intColumns)) Then

            longBegin = longNumberOfSeconds / 2

            If boolDebug Then
                Logfile(strIndent & "......Warning - Start position (plus any extra grabs) is past the end of the file")
                Logfile(strIndent & ".........Setting the begin value to: " & longBegin)
            End If
        End If

        If boolDebug Then
            Logfile(strIndent & "...Generating thumbnail")
        End If

        ' ##### Lets specify the size of each tile based on the size of the thumbnail and number of rows/columns #####
        intTileWidth = intThumbWidth / intColumns
        intTileHeight = (intThumbWidth / 1.763888) / intRows

        ' ##### Lets run FFmpeg with the specified options to generate the thumbnail #####
        Try

            strCommandOutput = CaptureShell(strCurrentLocation & "\ffmpeg.exe", _
                " -ss " & longBegin & _
                " -i " & Chr(34) & strFilenamePath & Chr(34) & " -vf " & Chr(34) & _
                "select=isnan(prev_selected_t)+gte(t-prev_selected_t\,20),yadif=0:-1:0,scale=" & _
                intTileWidth & ":" & intTileHeight & ",setsar=1:1,tile=" & _
                intColumns & "x" & intRows & Chr(34) & " -vframes 1 -vsync 0 -an " & Chr(34) & _
                strOutputFilename & "_s.jpg" & Chr(34), 100, True)

        Catch ex As Exception
            If boolDebug Then
                Logfile(strIndent & "......ERROR - Failed to generate the thumbnail: " & strOutputFilename & "_s.jpg")
            End If
            Exit Sub
        End Try

        ' ##### Lets check we have generated a thumbnail file #####
        ' ##### We create the thumb in the same folder as the source movie file. #####
        ' ##### Mediaportal then movies/duplicates the thumbs into the required directory #####
        If System.IO.File.Exists(strOutputFilename & "_s.jpg") Then
            If boolDebug Then
                Logfile(strIndent & "......Successfully generated thumbnail: " & strOutputFilename & "_s.jpg")
            End If
        Else
            If boolDebug Then
                Logfile(strIndent & "......ERROR - Failed to generate the thumbnail: " & strOutputFilename & "_s.jpg")
            End If
            Exit Sub
        End If

    End Sub


    Private Sub Logfile(ByVal strMessage As String)

        Dim strLogFile As String

        ' ##### Specify the location of the logfile #####
        strLogFile = strCurrentLocation & "\mtn_replacement.log"

        Try
            ' ##### Open the file #####
            Dim objfile As New System.IO.StreamWriter(strLogFile, True)

            ' ##### Write the new line #####
            objfile.WriteLine(Now() & " - " & strMessage)

            ' ##### Close the file #####
            objfile.Close()

        Catch ex As Exception

            If boolDebug Then
                MsgBox(ex.Message)
            End If
        End Try
    End Sub


    Function ConvertToSeconds(ByVal strDuration As String) As Long
        ' ##### Convert the durationof the movie to seconds (00:00:00 ----> XXXX seconds #####

        Dim longTotal As Long
        Dim arrDuration

        Try
            ' ##### Make sure we have a : in the duration (actually there should be 2 of them) #####
            If InStr(strDuration, ":") < 1 Then
                ConvertToSeconds = 0
                Exit Function
            End If

            ' ##### Lets split the duration based on : #####
            arrDuration = Split(strDuration, ":")

            ' ##### If we haven't got three parts (hours, minutes, seconds) then we have an issue #####
            If UBound(arrDuration) <> 2 Then
                ConvertToSeconds = 0
                Exit Function
            End If

            ' ##### Lets convert the hours to seconds #####
            If Val(arrDuration(0)) > 0 Then
                longTotal = Val(arrDuration(0)) * (60 * 60)
            End If

            ' ##### Lets convert the minutes to seconds and add to the hours value #####
            If Val(arrDuration(1)) > 0 Then
                longTotal = longTotal + (Val(arrDuration(1)) * 60)
            End If

            ' ##### Lets add the seconds to the running total from above #####
            If Val(arrDuration(2)) > 0 Then
                longTotal = longTotal + Val(arrDuration(2))
            End If

            ConvertToSeconds = longTotal

        Catch ex As Exception
            ConvertToSeconds = 0
        End Try
    End Function

    Public Function InIDE() As Boolean
        InIDE = Debugger.IsAttached
    End Function

    Function RegistryDebugFlag() As Boolean

        Try

            Dim objRegKey As RegistryKey
            Dim strValue As String

            objRegKey = Registry.LocalMachine.OpenSubKey("Software\MTN", True)

            strValue = objRegKey.GetValue("debug", 0.0)

            objRegKey.Close()

            If strValue = "1" Then
                RegistryDebugFlag = True
            Else
                RegistryDebugFlag = False
            End If

        Catch ex As Exception
            RegistryDebugFlag = False
        End Try

    End Function

End Module
